/*
 * Transfer Shell Commands Module (`tftp[.exe]', `ftp[.exe]')
 * $Id: shell-transfer.cpp 191 2005-10-29 15:32:33Z oxff $
 *
 * Queen on the left side, Hardcore Heaven (note mine! :D) on the right side.
 */
 
#include "shell-transfer.h"
#include <string>

extern "C"
{
	// wrappers around constructor and deconstructor to have nice dll interface
	
	void * CreateInstance()
	{
		return new ShellTransferModule();
	}

	void FreeInstance(void * pInstance)
	{
		delete (ShellTransferModule *) pInstance;
	}
}

bool ShellTransferModule::start()
{
	const char * szError;
	int iPos;
	
	m_pCollector->getShellManager()->registerParser(this);
	
	m_pTftpPattern = pcre_compile("tftp(.exe)? +(-i +)?(.*) +get +(.*)", PCRE_CASELESS, &szError, &iPos, 0);
	m_pFtpPatterns[0] = pcre_compile(".*open\\s+(.+)\\s+(\\d+)\\s+user\\s+(.+)\\s+(.+)\\s+.*\\s+get\\s+(\\S+)\\s+.*", PCRE_CASELESS | PCRE_UNGREEDY, &szError, &iPos, 0);
	m_pFtpPatterns[1] = pcre_compile(".*open\\s+(.+)\\s+(\\d+)\\s*\n\\s*(.+)\\s*\n\\s*(.+)\\s+.*\\s+get\\s+(\\S+)\\s+.*", PCRE_CASELESS | PCRE_UNGREEDY, &szError, &iPos, 0);
	
	return true;
}

void ShellTransferModule::stop()
{
	pcre_free(m_pTftpPattern);
	pcre_free(m_pFtpPatterns[0]);
	pcre_free(m_pFtpPatterns[1]);
	
	m_pCollector->getShellManager()->unregisterParser(this);
}

bool ShellTransferModule::parseCommand(const char * szLine, VirtualShell * pShell)
{
	int piOutput[5 * 3];
        int iResult;
        char * szURL;
        if(!m_pTftpPattern)
        	return false;

        if((iResult = pcre_exec(m_pTftpPattern, 0, szLine, strlen(szLine), 0, 0, piOutput, 5 * 3)) > 0)
        {
        	const char * szAddress, * szFileName;

        	pcre_get_substring(szLine, piOutput, iResult, iResult - 2, &szAddress);
        	pcre_get_substring(szLine, piOutput, iResult, iResult - 1, &szFileName);
        	
		asprintf(&szURL, "tftp://%s/%s", szAddress, szFileName);

		pcre_free_substring(szFileName);
		pcre_free_substring(szAddress);
		
		m_pCollector->getDownloadManager()->downloadFile(szURL);
		
		free(szURL);
		
		return true;
	}
	else if(!strncmp("ftp ", szLine, 4) || !strncmp("ftp.exe ", szLine, 8))
	{
		char * szInstructionFile = strstr(szLine, "-s:");
		
		if(!szInstructionFile)
			return false;
			
		szInstructionFile += 3;
			
		return parseFtpFile(pShell->getFileContent(szInstructionFile, 0));
	}

	return false;
}

bool ShellTransferModule::parseFtpFile(const char * szBuffer)
{
	int pnOffsets[3 * 6];
	int iResult;
	
	if((iResult = pcre_exec(m_pFtpPatterns[0], 0, szBuffer, strlen(szBuffer), 0, PCRE_NOTEMPTY, pnOffsets, 3 * 6)) > 0 || (iResult = pcre_exec(m_pFtpPatterns[1], 0, szBuffer, strlen(szBuffer), 0, PCRE_NOTEMPTY, pnOffsets, 3 * 6)) > 0)
        {                        
                const char * szHost, * szPort, * szUser, * szPassword, * szFileName;
                char * szResult;
                
                pcre_get_substring(szBuffer, pnOffsets, iResult, 1, &szHost);
                pcre_get_substring(szBuffer, pnOffsets, iResult, 2, &szPort);
                pcre_get_substring(szBuffer, pnOffsets, iResult, 3, &szUser);
                pcre_get_substring(szBuffer, pnOffsets, iResult, 4, &szPassword);
                pcre_get_substring(szBuffer, pnOffsets, iResult, 5, &szFileName);
                
                asprintf(&szResult, "ftp://%s:%s@%s:%s/%s", szUser, szPassword, szHost, szPort, szFileName);
                m_pCollector->getDownloadManager()->downloadFile(szResult);
                
                free(szResult);
                
                pcre_free_substring(szFileName);
                pcre_free_substring(szPassword);
                pcre_free_substring(szUser);
                pcre_free_substring(szPort);
                pcre_free_substring(szHost);
                
                return true;
        }

	return false;        
}
