/*
 * Simulates MS03-26 (Buffer Overrun In RPC Interface Could Allow Code
 * Execution).
 *
 * $Id: vuln-ms0326-subscription.cpp 126 2005-09-25 16:52:34Z tho $
 *
 */
 
#include "vuln-ms0326.h"
#include "vuln-ms0326-HDM.h"

#include <string.h>

void VulnerabilitySubscription::incomingData(unsigned char * pucData, unsigned int nLength)
{
	m_sBuffer.append((char *) pucData, nLength);
	
	while(!m_sBuffer.empty())
	{
		switch(m_iStage)
		{
		case 0:
			if(m_sBuffer.size() < sizeof(HDM_bindstr) - 1)
				return;

			if(memcmp(m_sBuffer.data(), HDM_bindstr, sizeof(HDM_bindstr)))
			{
				m_clLevel = CL_DROP;
				return;
			}
			
			m_pSocket->sendData(HDM_Reply, sizeof(HDM_Reply));
			
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HDM_bindstr));
			break;
		
		case 1:
			if(m_sBuffer.size() < sizeof(HDM_request1) - 1)
				return;
				
			if(memcmp(m_sBuffer.data()+0x194, HDM_request1+0x194, sizeof(HDM_request1) - (1+0x194)))
			{
				m_clLevel = CL_DROP;
				return;
			}
			
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HDM_request1));
			
			break;
			
		case 2:
			if(m_sBuffer.size() < sizeof(HDM_request2) - 1)
				return;
			
			{
				m_iShellcodeLength = (*(unsigned long *)m_sBuffer.data() - *(unsigned long *)(HDM_request2))*2;
			}

			if(*(unsigned long*)(m_sBuffer.data()+8) != *(unsigned long *)(HDM_request2+8) + m_iShellcodeLength/2)
			{
				m_clLevel = CL_DROP;
				return;
			}
		
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HDM_request2));
			m_clLevel = CL_OVERTAKE;
			
			break;
			
		case 3:
			if(m_sBuffer.size() < m_iShellcodeLength)
				return;
		
			m_sShellcode = m_sBuffer.substr(0,m_iShellcodeLength-1);

			{	
				unsigned long return_addr = *(unsigned int *) (m_sBuffer.data()+36);
				
				const char* target = NULL;
				for(int i=0; HDM_targets[i] != NULL; i++)
				{
					if(HDM_offsets[i] == return_addr)
						target= HDM_targets[i];
				}
				
				if(target != NULL)
					LOG(LT_LEVEL_MEDIUM | LT_STATUS | LT_EXPLOIT, "Got successfully exploited with MS03-26 vulnerability using offset for %s!",target);
				else
					LOG(LT_LEVEL_MEDIUM | LT_STATUS | LT_EXPLOIT, "Got successfully exploited with MS03-26 vulnerability using unknown offset!",target);
			
			}
			
			++m_iStage;
			m_sBuffer.erase(0, m_iShellcodeLength);
			
			break;
			
		case 4:
			if(m_sBuffer.size() < sizeof(HDM_request3) - 1)
				return;
				
			if(memcmp(m_sBuffer.data(), HDM_request3, sizeof(HDM_request3) - 1))
			{
				m_clLevel = CL_DROP;
				return;
			}
			
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HDM_request3));
			
			break;
			
		case 5:
			if(m_sBuffer.size() < sizeof(HDM_request4) - 1)
				return;
			
			m_clLevel = CL_DROP; // we're done now
			m_pCollector->getShellcodeDispatcher()->parseShellcode((unsigned char *) m_sShellcode.c_str(), m_iShellcodeLength);
			m_sBuffer.erase();
			break;
		}
	}
}

void VulnerabilitySubscription::connectionEtablished()
{
	DEBUG("Connection Established with vuln-ms03-26");
	m_clLevel = CL_UNSURE;
	m_iStage = 0;
	
	
}

void VulnerabilitySubscription::connectionClosed()
{
}

ConsumptionLevel VulnerabilitySubscription::consumptionLevel()
{
	if(m_clLevel == CL_DROP)
		DEBUG("vuln-ms0326 decided to be dropped in stage %i.", m_iStage);
	
	return m_clLevel;
}
