/*
 * Simulates MS04-11 (Remote Code Execution in LSASS Service).
 *
 * $Id: vuln-ms0411-subscription.cpp 179 2005-10-26 18:50:34Z oxff $
 *
 */
 
#include "vuln-ms0411.h"
#include "vuln-ms0411-hod.h"

#include <string.h>

void VulnerabilitySubscription::incomingData(unsigned char * pucData, unsigned int nLength)
{
	m_sBuffer.append((char *) pucData, nLength);
	
	while(!m_sBuffer.empty())
	{
		switch(m_iStage)
		{
		case 0:
			if(m_sBuffer.size() < sizeof(HOD_req1) - 1)
				return;
	
			if(memcmp(m_sBuffer.data(), HOD_req1, sizeof(HOD_req1) - 1))
			{
				m_clLevel = CL_DROP;
				return;
			}
			
			m_pSocket->sendData(HOD_Positive_Reply, sizeof(HOD_Positive_Reply) - 1);
			
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HOD_req1) - 1);
			
			break;
		
		case 1:
			if(m_sBuffer.size() < sizeof(HOD_req2) - 1)
				return;
				
			if(memcmp(m_sBuffer.data(), HOD_req2, sizeof(HOD_req2) - 1))
			{
				m_clLevel = CL_DROP;
				return;
			}
			
			m_pSocket->sendData(HOD_Positive_Reply, sizeof(HOD_Positive_Reply) - 1);
			
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HOD_req2) - 1);
			
			break;
			
		case 2:
			if(m_sBuffer.size() < sizeof(HOD_req3) - 1)
				return;
				
			if(memcmp(m_sBuffer.data(), HOD_req3, sizeof(HOD_req3) - 1))
			{
				m_clLevel = CL_DROP;
				return;
			}
			
			{
				const char * szOS = "Windows 5.1 ";
				char szResponse[128];
				
				for(int i = 0; i < 128; ++i)
					szResponse[i] = 'Z';
				
				for(int i = 0; szOS[i]; ++i)
					szResponse[48 + i * 2] = szOS[i];
				
				m_pSocket->sendData((unsigned char *) szResponse, sizeof(szResponse));
			}
			
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HOD_req3) - 1);
			m_clLevel = CL_OVERTAKE;
			
			break;
			
		case 3:
			if(m_sBuffer.size() < 47)
				return;
				
			if(memcmp(m_sBuffer.data() + 5, HOD_req4 + 5, 44 - 5))
			{
				m_clLevel = CL_DROP;
				return;
			}
			
			m_pSocket->sendData(HOD_Positive_Reply, sizeof(HOD_Positive_Reply) - 1);
			
			++m_iStage;
			m_sBuffer.erase(0, m_sBuffer.data()[3] + 4);
			
			break;
			
		case 4:
			if(m_sBuffer.size() < sizeof(HOD_req5) - 1)
				return;
				
			if(memcmp(m_sBuffer.data(), HOD_req5, sizeof(HOD_req5) - 1))
			{
				m_clLevel = CL_DROP;
				return;
			}
			
			m_pSocket->sendData(HOD_Positive_Reply, sizeof(HOD_Positive_Reply) - 1);
			
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HOD_req5) - 1);
			
			break;
			
		case 5:
			if(m_sBuffer.size() < sizeof(HOD_req6) - 1)
				return;
				
			if(memcmp(m_sBuffer.data(), HOD_req6, sizeof(HOD_req6) - 1))
			{
				m_clLevel = CL_DROP;
				return;
			}
			
			m_pSocket->sendData(HOD_Positive_Reply, sizeof(HOD_Positive_Reply) - 1);
			
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HOD_req6) - 1);
			
			break;
			
		case 6:
			if(m_sBuffer.size() < sizeof(HOD_req7) - 1)
				return;
				
			if(memcmp(m_sBuffer.data(), HOD_req7, sizeof(HOD_req7) - 1))
			{
				m_clLevel = CL_DROP;
				return;
			}

			m_pSocket->sendData(HOD_Positive_Reply, sizeof(HOD_Positive_Reply) - 1);
			
			++m_iStage;
			m_sBuffer.erase(0, sizeof(HOD_req7) - 1);
			
			break;
			
		case 7:
			if(m_sBuffer.size() < 160)
				return;
				
			++m_iStage;
			m_sBuffer.erase(0, 160);
			
			break;
			
		case 8:			
			if(m_sBuffer.size() < 1980)
				return;
				
			LOG(LT_LEVEL_MEDIUM | LT_STATUS | LT_EXPLOIT, "Got successfully exploited with MS04-11 vulnerability!");
			
			m_clLevel = CL_DROP; // we're done now
			m_pCollector->getShellcodeDispatcher()->parseShellcode((unsigned char *) m_sBuffer.data(), 1980);
			m_sBuffer.erase();
			
			break;
		}
	}
}

void VulnerabilitySubscription::connectionEtablished()
{
	m_clLevel = CL_UNSURE;
	m_iStage = 0;
	
	
}

void VulnerabilitySubscription::connectionClosed()
{
}

ConsumptionLevel VulnerabilitySubscription::consumptionLevel()
{
	if(m_clLevel == CL_DROP)
		DEBUG("vuln-ms0411 decided to be dropped in stage %i.", m_iStage);
	
	return m_clLevel;
}

